- date: 20210414
- author: ShiKaiWi

## 为什么坚持很难
一个人往往希望通过坚持做一件事情来获得某些改变（比如减重、成绩提升等），但是往往事与愿违，因此就会形成一个常识 —— 坚持很难。

我个人也是经常饱受其苦，作为一个程序员，我个人经常希望能够通过坚持来完成一件事情，来提升自己的技术水平，但是很多事情都没有能够坚持下来，最后能够提升技术水平的往往还是实际的工作。

因此我想在本文中，记录一下，我关于坚持这件事情的思考，搞清楚为什么坚持很难，在这个基础上面，来形成一套行之有用的方法论，从而让坚持这件事情成为一个可运作的、可重复的手段。

在本文中，我想通过逻辑，来推理出坚持难的原因，然后再对症下药，从而总结出相应的方法论。

首先，**坚持很难** 中的 **坚持** 更准确的定义是：在 **较长的一段时间内** **周期性** 地做一件事情。强调两点：
1. 较长时间，坚持一两天，显然是不符合定义的，也因此坚持一两天是很容易的事情。
2. 周期性是表明做这件事情不是出于三分钟热度，而且显然，在较长时间内做一件事情，我们必须保证周期性，如果没有间隔地持续完成，要么说明是极度的热爱，要么说明这件事情在百小时左右的可以完成的事情。

根据这个定义出发，我们进行推论，会发现一些奇怪的事情也可以算作是坚持：
1. 睡觉。
2. 吃饭。
3. 小的时候，去学校学习。
4. 步入社会，工作日上班。
5. 每天坚持打游戏。

如果按照一开始的定义，这些事情都会算作坚持，但是这个又会产生矛盾，因为这些事情并不难，周围大部分人，都能完成这样的坚持。

我们再看一些很难的例子：
1. 减肥。
2. 跨行业自学技能。
3. 坚持每天写一点寒暑假作业。

对比一下，我们发现，**坚持很难** 这个说法中的坚持定义，还需要在进行一下扩充：
1. 较长的一段时间内
2. 周期性
3. （新增）非强制性：强制性的坚持其实并不难，不坚持带来的可怕后果，导致不得不把坚持进行下去。
4. （新增）正向反馈周期较长：正向反馈的意思是指带来满足感（快感），对于玩游戏，这样的即时反馈较强的事情，要求坚持，实在是太过容易，但是对于减肥、学习等事情，每天的进步和改变是微乎其微的，得不到立即的正向反馈和激励，甚至会得到一些挫败感，往往是导致坚持失败的主要因素。

这样的话，我们就可以发现，**坚持很难** 这件事情，是非常符合常理的，从人的进化过程来讲，坚持这件事情简直就像是：在食物匮乏的年代，每天放弃眼前的可以捡到甜食（打游戏），而去费尽心思地去锻炼自己的狩猎能力（只能缓慢地提升）。

但是显然，**坚持**，是反人性的，但因为可以带来更加大的、长远的好处，所以很多人（包括我自己在内）都处于想坚持、坚持一小段时间、坚持放弃的处境里面。

## 怎么做到坚持
既然搞清楚了 **坚持很难** 这件事情的真实含义，那么我们自然希望能够对症下药，形成一套有效的坚持的方法论。

针对上面提到的坚持很难的 **坚持** 含义，我们可以逐个考虑如何攻破。

### 较长的一段时间
我们往往会在一开始，就会把自己吓傻，比如定下目标希望能够在今年看完一个开源项目的源码，这个源码如果有 20w 行，平均一天看 500 行（对于个一个工作者，已经很夸张了）的话，需要 400 天，也就是一年，明显这个 **坚持** 的难度会大大增加，也就是说我们的目标定的非常不合理，一旦中途出现了一些变故，产生挫败感，坚持就会失败。

方法：阶段性坚持。本质上，就是将目标分解，比如第一个目标，完成模块 A 的阅读和理解，大概会花两周的时间，完全理解了模块 A，那么这次坚持就算成功了。

### 周期性
在我的观点里面，很多人对于“周期性”存在一定的误解，其实周期性的目的是将一个需要长久的时间才能完成的任务零散地分解到每个周期里面，而这么做的一个重要原因就是坚持的事情在没有达到一定程度，如果中断坚持，就会让这件事的效果大打折扣，比如减肥中断一段时间，又会涨回来，比如学习一个新技能，在掌握之前，停止学习一段时间，由于人脑会淡忘，因此之前花了很大精力记忆、理解的知识和技能便会被遗忘，这个是非常令人沮丧的事情。

从这段分析，我们可以看出，周期性的目的是为了**对抗坚持过程中的中断行为带来的负面效果**，这么一看，我们实际上如果能够达到相同的效果，就没有必要保持这个周期性（每天、每周必须干点什么），比如对于学习而言，我们可以通过做好笔记，记录好当时自己的所学、所思、所得，在闲暇的时刻时常回顾，这样即使行为中断了，也不必担心遗忘带来的负面效果（当然进度变缓慢也是一个不好的事情）。

方法：打破周期性的恐惧和减少其负面效果。不必强行周期性，但是前提是能够降低周期中断的负面效果（比如完成思考的笔记），降低下次重启周期的难度。

### 非强制性
非强制性的坚持和强制性的坚持的区别在于，不坚持也不会带来额外的坏处，反而因为坚持本身需要付出额外的努力，从而导致难以为继。

个人觉得需要转变思路，或者更准确的说，需要转变自身的认知，需要认知到，**长期的坚持一定会带来非常大的收益（能够轻松超越 90% 的同领域者）这一点等价于不坚持将会损失这一本来属于自己的巨大收益（沦为 90% 的平庸者）**。

有了这个认知之后，就会为非强制性的坚持带来放弃的恐惧，进而完成非强制到强制的转换。

### 正向反馈周期较长
这一点的解决没有什么好方法，一般需要具体问题具体分析，但是核心思路是：**目标分解**。这个解决方法其实和第一点是一致的，也就是说目标分解，可以达到两个效果：
- 打破坚持一定需要非常长时间的定论。
- 减小正向反馈周期的长的缺点。

另外还有一个认知上的方案，需要理解，人脑是希望完成即时享乐的，这个是人类这个生物的本能，也正因为是本能，所以一旦完全服从于它，你也就是泯然众人了，如果在某些领域能够做到反本能的行为，能够达到长期的收益，那么就会有非常大的概率完成非凡的成就。

## 总结
行为上：
- 分解目标，完成阶段性的坚持，缩短正向反馈的周期。
- 多做总结，降低周期性的负面效果，打破强周期性的恐惧。

认知上：
- 长期的坚持一定会带来非常大的收益等价于不坚持将会损失这一本来属于自己的巨大收益。
- 坚持本身就是反人性、反本能的，如果能够做到，就会有非常大的概率完成非凡的成就。
