- date: 20231022
- author: czhang

# 浏览器进程

    1. 浏览器进程（用户交互、子进程管理、文件存粗）
    2. 渲染进程（运行在安全沙箱里保障安全）
    3. 网络进程

# 渲染顺序流水线

1. 构建 DOM 树
2. 样式计算

   1. 把 CSS 转换为浏览器结构 sytleSheets
   2. 转换样式表的属性值，使其标准化
   3. 计算 Dom 树每个节点具体样式

3. 布局阶段

   1. 创建布局树
   2. 布局计算

4. 分层

   - 渲染引擎需要为特定的节点生成专用的图层，并声称一颗对应的图层树(LayerTree)。
   - 并不是布局树的每个节点都包含一个图层，如果一个集诶单没有对应的层，那么这个节点就从属于父节点的图层
   - 单独一个图层：
     - 拥有层叠上下文属性的元素，会被提升为单独的一层
     - 需要剪裁的地方会被创建为图层(如文字过多，出现滚动等)

5. 图层绘制
6. 栅格化操作
   - 实际由浏览器的合成线程完成

# 整体流程

1. 渲染进程将 HTML 内容转换为能够读懂的 DOM 树结构
2. 渲染引擎把 CSS 样式表转化为浏览器可以理解的 sytleSheets, 计算出 DOM 节点的样式
3. 创建布局树，并计算元素的布局信息
4. 对布局树进行分层，并生成分层树
5. 为每个图层生成绘制列表，并将其提交到合成进程
6. 合成进程将图层分为土块，并在光栅化线程池中将图块转换成位图
7. 合成线程发送绘制图块命令 DrawQuad 给浏览器进程
8. 浏览器进程根据 DrawQuad 消息生成页面，并显示到显示器上

# 相关概念

1. 重排

- 更新元素几何属性，如宽度、高度，会重新布局

2. 重绘

- 更改如背景色，布局不变，直接进入绘制，省去布局和分层阶段。

3. 合成

- 改不要布局，也不要重绘的属性，如动画效果,叫合成。
